unit Calk_Matr;
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ToolWin, ComCtrls, Menus, Buttons, ExtCtrls, Grids, Spin,
  Gauges, Drobi, Registry;

type
  TCalkWindow = class(TForm)
    MainMenu: TMainMenu;
    ChisloMenu: TMenuItem;
    SpravkaMenu: TMenuItem;
    Help: TMenuItem;
    N6: TMenuItem;
    AboutProgram: TMenuItem;
    Umn: TMenuItem;
    Razd: TMenuItem;
    MC: TButton;
    MR: TButton;
    Bevel1: TBevel;
    MemoryLabel: TLabel;
    C: TButton;
    CE: TButton;
    DetBut: TButton;
    Mplus: TButton;
    Mminus: TButton;
    PlusBut: TButton;
    MinusBut: TButton;
    Umnoghe: TButton;
    Delite: TButton;
    Ravno: TButton;
    ObratBut: TButton;
    MatrixViewer: TStringGrid;
    Col: TSpinEdit;
    Row: TSpinEdit;
    Bevel2: TBevel;
    Label2: TLabel;
    Label3: TLabel;
    N1: TMenuItem;
    N2: TMenuItem;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Button1: TButton;
    Sel: TButton;
    Bevel3: TBevel;
    Bevel4: TBevel;
    RangBut: TButton;
    TranBut: TButton;
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RowChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CEClick(Sender: TObject);
    procedure CClick(Sender: TObject);
    procedure DetButClick(Sender: TObject);
    procedure ObratButClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MCClick(Sender: TObject);
    procedure MRClick(Sender: TObject);
    procedure MplusClick(Sender: TObject);
    procedure MminusClick(Sender: TObject);
    procedure PlusButClick(Sender: TObject);
    procedure RavnoClick(Sender: TObject);
    procedure MinusButClick(Sender: TObject);
    procedure UmnogheClick(Sender: TObject);
    procedure DeliteClick(Sender: TObject);
    procedure SelClick(Sender: TObject);
    procedure UmnClick(Sender: TObject);
    procedure RazdClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure RangButClick(Sender: TObject);
    procedure TranButClick(Sender: TObject);
    procedure MatrixViewerMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure AboutProgramClick(Sender: TObject);
    procedure HelpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  DetQWEst:Integer;
  end;

  TMatrix = object {}
    Row,Col: Integer; {, }
    Cells: array of array of TDrob; { }

    Procedure Create (R,C:integer); { (, )}


    Procedure Plus (Matrix:TMatrix);{ }
    Procedure Minus (Matrix:TMatrix);{}

    Procedure Minor (Ro,Co:Integer); {  (Ro,Co)}

    Procedure Det(var D:TDrob);{ }

    Procedure Zeroizing; { }
    Function Zero:boolean;{   }

    Procedure Joined;{ }

    Procedure Tran;{ }
    Function Inverse:boolean;{  (   )}

    Procedure Multiply(Matrix:TMatrix);{}

    Procedure Separate(Matrix:TMatrix);{}
    Function Rang:integer; { }

    Procedure ToMatrixViewer; {   }
    Procedure FromMatrixViewer; {,   ,  }

    Procedure Det2(Var D:TDrob);
  end;
  TProcedure = (Plus,Minus,Multiply,Separate,NoValue);

var
  CalkWindow: TCalkWindow;
  Memory: TMatrix;{ }
  Operand:TMatrix;{ }
  Matr:TMatrix;
  Proc: TProcedure;
implementation

uses Vir, OpredQw, IdexUnit, AboutBox;

{$R *.DFM}

Procedure Sizer;
begin
  With CalkWindow.MatrixViewer do begin
    DefaultRowHeight:=25;
    DefaultColWidth:=62;
    IF DefaultRowHeight*(RowCount+1)>Height then
       DefaultRowHeight:=Height div (RowCount+1);
    IF DefaultColWidth*(ColCount+1)>Width then
       DefaultColWidth:=  Width div (ColCount+1);
  end;
end;

Procedure ToNumber;
Var i:integer;
begin
  With CalkWindow.MatrixViewer do begin
    For i:=1 to RowCount do
      Cells[0,i]:=IntToStr(i);
    For i:=1 to ColCount do
      Cells[i,0]:=IntToStr(i);
  end;
end;

Procedure TMatrix.Create (R,C:integer);
begin
  Row:=R; Col:=C;
  SetLength(Cells,R,C);
end;


Procedure TMatrix.Zeroizing;
Var i,j:integer;
begin
  For i:= 0 to Row-1 do
    For j:= 0 to Col-1 do begin
      Cells[i,j].C:=0;
      Cells[i,j].Z:=1;
    end;
end;

Function TMatrix.Zero:boolean;
Var i,j:integer;
    b:boolean;
begin
  b:=true;
  For i:= 0 to Row-1 do
    For j:= 0 to Col-1 do
      If Cells[i,j].C<>0 then b:=false;
  result:=b;
end;


Procedure TMatrix.Plus (Matrix:TMatrix);
Var i,j:integer;
begin
  For i:= 0 to Row-1 do
    For j:= 0 to Col-1 do
      Cells[i,j].Plus(Matrix.Cells[i,j]);
end;

Procedure TMatrix.Minus (Matrix:TMatrix);
Var i,j:integer;
begin
  For i:= 0 to Row-1 do
    For j:= 0 to Col-1 do
      Cells[i,j].Minus(Matrix.Cells[i,j]);

end;

Procedure TMatrix.Multiply(Matrix:TMatrix);
Var i,j,k:integer;
    Matr:TMatrix;
    Drob:TDrob;
begin
    Matr.Create(Row,Matrix.Col);
    Matr.Zeroizing;
    For i:= 0 to Row-1 do
      For j:= 0 to Matrix.Col-1 do
	       For k:= 0 to Col-1 do begin
	         Drob:=Matrix.Cells[k,j];
	         Drob.Multiply(Cells[i,k]);
	         Matr.Cells[i,j].Plus(Drob);
	       end;
    Create(Row,Matrix.Col);
    Cells:=Matr.Cells;
end;

Procedure TMatrix.Minor (Ro,Co:Integer);
Var Matr:TMatrix;
    i,j,i1,j1:integer;
begin
  {  }
  //1.   
  //2.        
  //3.    .
  If (Row>1) and (Col>1) then
   Matr.Create(Row-1,Col-1)
  else begin
    Matr.Create(1,1);
    Matr.Cells[0,0].C:=1;
    Matr.Cells[0,0].Z:=1;
  end;
  i1:=-1;
  For i:= 0 to Row-1 do begin
    If i<>Ro then i1:=i1+1;
    j1:=-1;
    For j:= 0 to Col-1 do begin
      If (i<>Ro) and (j<>Co) then begin
      	j1:=j1+1;
      	Matr.Cells[i1,j1]:=Cells[i,j];
      end;
    end;
  end;
  Create(Matr.Row,Matr.Col);
  Cells:=Matr.Cells;
end;




Procedure TMatrix.Det2(Var D:TDrob);{ }
Var Matr:TMatrix;
    i:integer;
    R:TDrob;
begin
  // .
  //1. 1-  1-      ;
  //2.  2-  1-      ;
  //3.   n- ,  .
  D.C:=0; D.Z:=1;
  For i:= 0 to Col-1 do begin
    R.C:=0; R.Z:=1;
    Matr.Create(Row,Col);
    Matr.Cells:=Cells;
    IF Col>1 then begin
      Matr.Minor(i,0);
      Matr.Det2(R);
      R.Multiply(Cells[i,0]);
    end
    else R:=Cells[i,0];
    If (2+i)div 2 = (2+i)/2 then
      D.Plus(R)
    else
      D.Minus(R);
  end;
  //D.Simplify;
end;

Procedure TMatrix.Det(Var D:TDrob);
begin
  Det2(D);
  D.Simplify;
end;

Procedure TMatrix.Joined;
Var Drob:Tdrob;
    Matrix:TMatrix;
    Matr:TMatrix;
    i,j:integer;
Begin
  {  }
  // 1.  
  // 2.  
  // 3.    .
  Matr.Create(Row,Col);
  Matr.Zeroizing;
  For i:= 0 to Row-1 do
    For j:= 0 to Col-1 do begin
      Matrix.Create(Row,Col);
      Matrix.Cells:=Cells;
      Matrix.Minor (i,j);
      Matrix.Det(Drob);
      If (2+i+j)div 2 = (2+i+j)/2 then
	Matr.Cells[i,j].Plus(Drob)
      else begin
	Matr.Cells[i,j].Minus(Drob);
      end;
    end;
  Cells:=Matr.Cells;
end;

Function TMatrix.Inverse:boolean;
Var Drob:TDrob;
    i,j:integer;
    result1:boolean;
begin
  {  }
  //1.  
  //2.  
  //3.   (,   . .)
  //     (b j,i = A i,j / D).
  Det(Drob);
  If Drob.C<>0 then begin
    Joined; Tran;
    For i:= 0 to Row-1 do
      For j:= 0 to Col-1 do
	Cells[i,j].Separate(Drob);
    result1:=true;
  end
  else begin
    result1:=false;
    VirForm.ShowModal;
  end;
  result:=result1;
end;

Function TMatrix.Rang:integer;
Var Matrix:TMatrix;
    Drob:TDrob;
    Rang1,Rang2:integer;
    i,j:integer;
begin
   //    0, 
   //      
   //.
   Rang1:=0;
   Det(Drob);
   If (Drob.C=0) and (Row>1) then
     For i:= 0 to Row-1 do
       For j:= 0 to Col-1 do begin
       	 Matrix.Create(Row,Col);
         Matrix.Cells:=Cells;
       	 Matrix.Minor(i,j);
       	 Rang2:=Matrix.Rang;
         If Rang2>Rang1 then Rang1:=Rang2;
       end
   else Rang1:=Row;
   IF (Drob.C=0) and (Row=1) then Rang1:=0;
   Result:=Rang1;
end;


Procedure TMatrix.Separate;
Var Matr:TMatrix;
begin
  Matr.Create(Row,Col);
  Matr.Cells:=Cells;
  If Matrix.Inverse then begin
    Matrix.Multiply(Matr);
    Create(Matrix.Row,Matrix.Col);
    Cells:=Matrix.Cells;
  end;
end;

Procedure TMatrix.Tran;
Var Matr:TMatrix;
    i,j:integer;
begin
  Matr.Create(Col,Row);
  For i:= 0 to Row-1 do
    For j:= 0 to Col-1 do
      Matr.Cells[j,i]:=Cells[i,j];
  Create(Col,Row);
  Cells:=Matr.Cells;
end;
Procedure TMatrix.FromMatrixViewer;
Var i,j,i1,j1,k,len:integer;
    S:string;
  Procedure KillStr(var Str:string);
  var i,k,i2:integer;
      Str2:string;
  begin
    i:=1;
    While i<=Length(str) do begin
      If (not (Str[i] in ['/','0'..'9']))and not((Str[i]='-') and (i=1))
	 then begin Delete(Str,i,1); i:=i-1 end;
      i:=i+1;
    end;
    k:=0; Str2:=Str; i2:=0;
    For i:= 1 to Length(Str) do begin
      Inc(i2);
      If Str[i]='/' then begin
        k:=k+1;
        if k>1 then begin
          Delete(Str2,i2,1);
          Dec(i2); Dec(k);
        end;
      end;
    end;
    Str:=Str2;
    If (Pos('0/',Str)=1) or (Pos('/',Str)=1)
      or (Pos('/0',Str)<>0) then Str:='';
    If Str='' then str:='0';
  end;
begin
  i:=CalkWindow.Row.Value;
  j:=CalkWindow.Col.Value;
  Create(i,j);
  For i:=0 to Row-1 do begin
    j1:=i+1;
    For j:= 0 to Col-1 do begin
      i1:=j+1;
      S:=CalkWindow.MatrixViewer.Cells[i1,j1];
      KillStr(S);
      CalkWindow.MatrixViewer.Cells[i1,j1]:=S;
      k:=Pos('/',S);
      If length(S)<11 then
      If k>0 then begin
	Len:=Length(S);
	Delete(S,k,Len-k+1);
	Cells[i,j].C:=StrToInt(S);
	S:=CalkWindow.MatrixViewer.Cells[i1,j1];
	Delete(S,1,k);
	Cells[i,j].Z:=StrToInt(S);
      end
      else begin
	Cells[i,j].C:=StrToInt(S);
	Cells[i,j].Z:=1;
      end;
      Cells[i,j].Simplify;
    end;
  end;
end;

Procedure TMatrix.ToMatrixViewer;
var i,j,i1,j1:integer;
     bool:boolean;
begin
  CalkWindow.MatrixViewer.RowCount:=Row+1;
  CalkWindow.MatrixViewer.ColCount:=Col+1;
  CalkWindow.Row.Value:=Row;
  CalkWindow.Col.Value:=Col;
  bool:=true;
  For i:=0 to Row-1 do begin
    j1:=i+1;
    For j:= 0 to Col-1 do begin
      i1:=j+1;
      If not((Cells[i,j].C>32767) or
	(Cells[i,j].C<-32768) or
	(Cells[i,j].Z>32767) or
	(Cells[i,j].C<-32768)) then begin
	Cells[i,j].Simplify;
	If Cells[i,j].Z=1 then
	  CalkWindow.MatrixViewer.Cells[i1,j1]:=IntToStr(Cells[i,j].C)
	else
	  CalkWindow.MatrixViewer.Cells[i1,j1]:=IntToStr(Cells[i,j].C)+
	    '/'+IntToStr(Cells[i,j].Z);
      end
      else bool:=false;
    end;
  end;
  If not bool then begin
    For i:= 1 to CalkWindow.MatrixViewer.RowCount do
      For j:= 1 to CalkWindow.MatrixViewer.ColCount do
	CalkWindow.MatrixViewer.Cells[j,i]:='';
    IndexForm.Show;
  end;
end;

procedure TCalkWindow.RadioButton1Click(Sender: TObject);
begin
  MatrixViewer.Options:=MatrixViewer.Options+[goEditing];
end;

procedure TCalkWindow.RadioButton2Click(Sender: TObject);
begin
  MatrixViewer.Options:=MatrixViewer.Options-[goEditing];
end;

procedure TCalkWindow.RowChange(Sender: TObject);
begin
  If Col.Text='' then Col.Value:=1;
  If Row.Text='' then Row.Value:=1;
  If Col.Value>Col.MaxValue then Col.Value:=Col.MaxValue;
  If Row.Value>Row.MaxValue then Row.Value:=Row.MaxValue;

  MatrixViewer.RowCount:=Row.Value+1;
  MatrixViewer.ColCount:=Col.Value+1;
  Sizer;
  ToNumber;
  If (Proc<>NoValue) and (Row.Value<>Col.Value) then
    TranBut.Enabled:=False
  else
    TranBut.Enabled:=True;
  If Row.Value<>Col.Value then begin
    RangBut.Enabled:=false;
    DetBut.Enabled:=false;
    Sel.Enabled:=False;
    ObratBut.Enabled:=false;
    Button1.Enabled:=false;
  end
  else begin
    If Proc=NoValue then begin
       RangBut.Enabled:=True;
       DetBut.Enabled:=True;
    end;
    Sel.Enabled:=True;
    ObratBut.Enabled:=True;
    Button1.Enabled:=True;
  end;
  If MemoryLabel.Visible and
    ((Row.Value<>Memory.Row) or
    (Col.Value<>Memory.Col)) then begin
    MPlus.Enabled:=false;
    MMinus.Enabled:=false;
  end
  else begin
    MPlus.Enabled:=True;
    MMinus.Enabled:=True
  end;
end;

procedure TCalkWindow.FormCreate(Sender: TObject);
Var OldCursor:TCursor;
begin
  OldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  Left:=Screen.DesktopWidth div 2 - Width div 2;
  Top:=Screen.DesktopHeight div 2 - Height div 2;
  Proc:=NoValue;
  Operand.Create(4,4);
  Memory.Create(4,4);
  Memory.Zeroizing;
  Operand.Zeroizing;
  ToNumber;
  Sizer;
  Ravno.Enabled:=False;
  Screen.Cursor:=OldCursor;
end;

procedure TCalkWindow.CEClick(Sender: TObject);
Var i,j:integer;
begin
  For i:= 1 to MatrixViewer.RowCount do
    For j:= 1 to MatrixViewer.ColCount do
      MatrixViewer.Cells[j,i]:='';
  Operand.Zeroizing;
end;

procedure TCalkWindow.CClick(Sender: TObject);
Var i,j:integer;
begin
  For i:= 1 to MatrixViewer.RowCount do
    For j:= 1 to MatrixViewer.ColCount do
      MatrixViewer.Cells[j,i]:='';
  Ravno.Enabled:=false;
  Matr.Zeroizing;
  Operand.Zeroizing;
  Proc:=NoValue;
end;

procedure TCalkWindow.DetButClick(Sender: TObject);
Var Drob:TDrob;
    OldCursor:TCursor;
begin
  {  . TMatrix.Det}
  OldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  Operand.FromMatrixViewer;
  Operand.Det(Drob);
  Operand.Create(1,1);
  Operand.Cells[0,0]:=Drob;
  Operand.ToMatrixViewer;
  Screen.Cursor:=OldCursor;
end;

procedure TCalkWindow.ObratButClick(Sender: TObject);
Var OldCursor:TCursor;
begin
  OldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;

  Operand.FromMatrixViewer;
  Operand.Inverse;
  Operand.ToMatrixViewer;

  Screen.Cursor:=OldCursor;
end;

procedure TCalkWindow.Button1Click(Sender: TObject);
Var OldCursor:TCursor;
begin
  OldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;

  Operand.FromMatrixViewer;
  Operand.Joined;
  Operand.ToMatrixViewer;

  Screen.Cursor:=OldCursor;
end;

procedure TCalkWindow.MCClick(Sender: TObject);
begin
  Memory.Zeroizing;
  MemoryLabel.Visible:=False;
  MC.Enabled:=False;
  MR.Enabled:=False;
  MPlus.Enabled:=True;
  MMinus.Enabled:=True;
end;

procedure TCalkWindow.MRClick(Sender: TObject);
begin
  If MemoryLabel.Visible then Memory.ToMatrixViewer;
  MPlus.Enabled:=True;
  MMinus.Enabled:=True;
end;

procedure TCalkWindow.MplusClick(Sender: TObject);
Var Matr:TMatrix;
begin
  If not MemoryLabel.Visible then begin
    Memory.FromMatrixViewer;
  end
  else begin
    Matr.FromMatrixViewer;
    Memory.Plus(Matr)
  end;
  If Memory.Zero then begin
    MemoryLabel.Visible:=False;
    MC.Enabled:=False;
    MR.Enabled:=False;
  end
  else begin
    MemoryLabel.Visible:=True;
    MC.Enabled:=True;
    MR.Enabled:=True;
  end;
end;

procedure TCalkWindow.MminusClick(Sender: TObject);
Var Matr:TMatrix;
begin
  If not MemoryLabel.Visible then begin
    Memory.Zeroizing;
  end;
  Matr.FromMatrixViewer;
  Memory.Minus(Matr);
  If Memory.Zero then begin
    MemoryLabel.Visible:=False;
    MC.Enabled:=False;
    MR.Enabled:=False;
  end
  else begin
    MemoryLabel.Visible:=True;
    MC.Enabled:=True;
    MR.Enabled:=True;
  end;
end;

procedure TCalkWindow.PlusButClick(Sender: TObject);
Var i,j:integer;
begin
  Operand.FromMatrixViewer;
  Proc:=Plus;
  Col.Enabled:=False;
  Row.Enabled:=False;
  DetBut.Enabled:=False;
  RangBut.Enabled:=False;
  Ravno.Enabled:=True;
  If Col.Value<>Row.Value then
    TranBut.Enabled:=False;
  For i:= 1 to MatrixViewer.RowCount do
    For j:= 1 to MatrixViewer.ColCount do
      MatrixViewer.Cells[j,i]:='';
end;

procedure TCalkWindow.RavnoClick(Sender: TObject);
Var  OldCursor:TCursor;
begin
  OldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  Matr.FromMatrixViewer;
  Case Proc of
    Plus:     Operand.Plus(Matr);
    Minus:    Operand.Minus(Matr);
    Multiply: Operand.Multiply(Matr);
    Separate: Operand.Separate(Matr);
  end;
  Col.Enabled:=True;
  Row.Enabled:=True;
  If Row.Value=Col.Value then begin
     DetBut.Enabled:=True;
     RangBut.Enabled:=true;
  end;
  TranBut.Enabled:=true;
  Proc:=NoValue;
  Operand.ToMatrixViewer;
  Ravno.Enabled:=False;
  Screen.Cursor:=OldCursor;
end;

procedure TCalkWindow.MinusButClick(Sender: TObject);
Var i,j:integer;
begin
  Operand.FromMatrixViewer;
  Proc:=Minus;
  Col.Enabled:=False;
  Row.Enabled:=False;
  DetBut.Enabled:=False;
  RangBut.Enabled:=False;
  Ravno.Enabled:=True;
  If Col.Value<>Row.Value then
    TranBut.Enabled:=False;
  For i:= 1 to MatrixViewer.RowCount do
    For j:= 1 to MatrixViewer.ColCount do
      MatrixViewer.Cells[j,i]:='';
end;

procedure TCalkWindow.UmnogheClick(Sender: TObject);
Var i,j:integer;
begin
  Operand.FromMatrixViewer;
  Proc:=Multiply;
  Col.Enabled:=true;
  Row.Value:=Col.Value;
  Row.Enabled:=False;
  DetBut.Enabled:=False;
  RangBut.Enabled:=False;
  Ravno.Enabled:=True;
  
  For i:= 1 to MatrixViewer.RowCount do
    For j:= 1 to MatrixViewer.ColCount do
      MatrixViewer.Cells[j,i]:='';
end;

procedure TCalkWindow.DeliteClick(Sender: TObject);
Var i,j:integer;
begin
  Operand.FromMatrixViewer;
  Proc:=Separate;
  Col.Value:=Row.Value;
  Col.Enabled:=False;
  Row.Enabled:=false;
  DetBut.Enabled:=False;
  RangBut.Enabled:=False;
  Ravno.Enabled:=True;
  For i:= 1 to MatrixViewer.RowCount do
    For j:= 1 to MatrixViewer.ColCount do
      MatrixViewer.Cells[j,i]:='';
end;

procedure TCalkWindow.SelClick(Sender: TObject);
Var i,j:integer;
    Drob,Drob2:TDrob;
    OldCursor:TCursor;
begin
  {  .}
  {   -  (5):
       ()
       .
   1.     (det<>0)
   2.   
   3.  -    ,
         
       .}
  OpredQ.Caption:= ' ?';
  OpredQ.ShowModal;
 If OpredQw.KeyBut then begin
  OldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  Matr.FromMatrixViewer;
  Matr.Zeroizing;
  Randomize;
  Repeat
    For i:= 0 to Matr.Row-1 do
      For j:=0 to Matr.Col-1 do begin
	Matr.Cells[i,j].C:=random(5)-2;
      end;
    Matr.Det(Drob);
  Until (Drob.C<>0);
  Drob2.Z:=1;
  Drob2.C:=DetQWEST;
  Drob2.Separate(Drob);
  j:=random(Matr.Col-1)+1;
  for i:= 0 to Matr.Row-1 do
    Matr.Cells[i,j-1].Multiply(Drob2);
  Matr.ToMatrixViewer;
  Screen.Cursor:=OldCursor;
 end;
end;

procedure TCalkWindow.UmnClick(Sender: TObject);
Var i,j:integer;
    Drob:TDrob;
    INach,IKon,
    JNach,JKon:integer;
begin
  OpredQ.Caption:='  ?';
  OpredQ.ShowModal;
 If OpredQw.KeyBut then begin
  Matr.FromMatrixViewer;
  Drob.C:=DetQwest;
  Drob.Z:=1;
  If RadioButton2.Checked then begin
     INach:=MatrixViewer.Selection.Top-1;
     IKon:=MatrixViewer.Selection.Bottom-1;
     JNach:=MatrixViewer.Selection.Left-1;
     JKon:=MatrixViewer.Selection.Right-1;
  end
  else begin
     INach:=0; IKon:=Matr.Row-1;
     JNach:=0; JKon:=Matr.Col-1;
  end;
  For i:= INach to IKon do
    For j:= JNach to JKon do
      Matr.Cells[i,j].Multiply(Drob);
  Matr.ToMatrixViewer;
 end;
end;

procedure TCalkWindow.RazdClick(Sender: TObject);
Var i,j:integer;
    Drob:TDrob;
    INach,IKon,
    JNach,JKon:integer;
begin
  OpredQ.Caption:='  ?';
  OpredQ.ShowModal;
 If OpredQw.KeyBut then begin
  Matr.FromMatrixViewer;
  Drob.C:=DetQwest;
  Drob.Z:=1;
  If RadioButton2.Checked then begin
     INach:=MatrixViewer.Selection.Top-1;
     IKon:=MatrixViewer.Selection.Bottom-1;
     JNach:=MatrixViewer.Selection.Left-1;
     JKon:=MatrixViewer.Selection.Right-1;
  end
  else begin
     INach:=0; IKon:=Matr.Row-1;
     JNach:=0; JKon:=Matr.Col-1;
  end;
  For i:= INach to IKon do
    For j:= JNach to JKon do
      Matr.Cells[i,j].Separate(Drob);
  Matr.ToMatrixViewer;
 end;
end;

procedure TCalkWindow.N1Click(Sender: TObject);
Var i,j:integer;
    Drob:TDrob;
    INach,IKon,
    JNach,JKon:integer;
begin
  OpredQ.Caption:=' ?';
  OpredQ.ShowModal;
 If OpredQw.KeyBut then begin
  Matr.FromMatrixViewer;
  Drob.C:=DetQwest;
  Drob.Z:=1;
  If RadioButton2.Checked then begin
     INach:=MatrixViewer.Selection.Top-1;
     IKon:=MatrixViewer.Selection.Bottom-1;
     JNach:=MatrixViewer.Selection.Left-1;
     JKon:=MatrixViewer.Selection.Right-1;
  end
  else begin
     INach:=0; IKon:=Matr.Row-1;
     JNach:=0; JKon:=Matr.Col-1;
  end;
  For i:= INach to IKon do
    For j:= JNach to JKon do
      Matr.Cells[i,j].Plus(Drob);
  Matr.ToMatrixViewer;
 end;
end;

procedure TCalkWindow.N2Click(Sender: TObject);
Var i,j:integer;
    Drob:TDrob;
    INach,IKon,
    JNach,JKon:integer;
begin
  OpredQ.Caption:=' ?';
  OpredQ.ShowModal;
 If OpredQw.KeyBut then begin
  Matr.FromMatrixViewer;
  Drob.C:=DetQwest;
  Drob.Z:=1;
  If RadioButton2.Checked then begin
     INach:=MatrixViewer.Selection.Top-1;
     IKon:=MatrixViewer.Selection.Bottom-1;
     JNach:=MatrixViewer.Selection.Left-1;
     JKon:=MatrixViewer.Selection.Right-1;
  end
  else begin
     INach:=0; IKon:=Matr.Row-1;
     JNach:=0; JKon:=Matr.Col-1;
  end;
  For i:= INach to IKon do
    For j:= JNach to JKon do
      Matr.Cells[i,j].Minus(Drob);
  Matr.ToMatrixViewer;
 end;
end;

procedure TCalkWindow.RangButClick(Sender: TObject);
Var Rang1:integer;
    OldCursor:TCursor;
begin
  OldCursor:=Screen.Cursor;
  Screen.Cursor:=crHourGlass;
  Matr.FromMatrixViewer;
  Rang1:=Matr.Rang;
  Matr.Create(1,1);
  Matr.Cells[0,0].C:=Rang1;
  Matr.Cells[0,0].Z:=1;
  Matr.ToMatrixViewer;
  Screen.Cursor:=OldCursor;
end;

procedure TCalkWindow.TranButClick(Sender: TObject);
begin
  Matr.FromMatrixViewer;
  Matr.Tran;
  Matr.ToMatrixViewer;
end;

procedure TCalkWindow.MatrixViewerMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var X2,Y2:integer;
begin
  X2:=X div MatrixViewer.DefaultColWidth;
  Y2:=Y div MatrixViewer.DefaultRowHeight;
  If (X2<>0) and (Y2<>0)and (X2<=MatrixViewer.ColCount)and (Y2<=MatrixViewer.RowCount) then
    MatrixViewer.Hint:=MatrixViewer.Cells[X2,Y2]
  else
    MatrixViewer.Hint:='';
end;

procedure TCalkWindow.AboutProgramClick(Sender: TObject);
begin
  AboutBoxForm.Show;
end;

procedure TCalkWindow.HelpClick(Sender: TObject);
Var Browser,HelpFileName:string;
    Reg: TRegistry;
    Keygood:boolean;

Function NumberChar(Str:String; ch:char):integer;
Var i,k: integer;
begin
  k:=0;
  For i:= 1 to Length(Str) do
    If Str[i]=Ch then k:=i;
  NumberChar:=K;
end;

Function Mid (Str:String; b,e:integer):string;
Var i:integer;
    Str2:string;
Begin
  Str2:='';
  For i:= b to e do
    Str2:=Str2+Str[i];
  Mid:=Str2;
End;

begin
  HelpFileName:=Mid(ParamStr(0),1,NumberChar(ParamStr(0),'\'))+'Help.htm';
  Browser:='';

  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_CLASSES_ROOT;
    KeyGood:=Reg.OpenKey('htmlfile\shell\open\command',False);
    If KeyGood then
      Browser:=Reg.ReadString('');
  finally
    Reg.Free;
  end;
  WinExec(PChar(Browser+' '+HelpFileName),1);

end;

end.
