Unit Drobi;

Interface

Type
  TDrob = object
    C,Z:Integer;
    Public
      Procedure Simplify;
      Procedure Plus (Drob:TDrob);
      Procedure Minus (Drob:TDrob);
      Procedure Multiply(Drob:TDrob);
      Procedure Separate(Drob:TDrob);
      Procedure Stepen(St:Byte);
  end;

Implementation

Procedure TDrob.Stepen(St:Byte);
Var i:integer;
    Drob:TDrob;
begin
  If St=0 then begin
    C:=1;
    Z:=1;
  end;
  Drob.C:=C; Drob.Z:=Z;
  For i:= 2 to St do
     Multiply(Drob);
  Simplify;
end;

Procedure TDrob.Simplify;
Var x,y,d:integer;
begin
  {Restriction;}
  If z<0 then begin
    c:=-c;
    z:=-z;
  end;
  If (c=0) or (z=0) then begin
    c:=0;
    z:=1;
  end
  else begin
    x:=ABS(c); y:=ABS(z);
    if x>y then begin
      x:=x+y;
      y:=x-y;
      x:=x-y;
    end;
    d:=x;
    If (c div d = c/d) and (z div d=z/d) then begin
      c:=c div d;
      z:=z div d;
      x:=ABS(c); y:=ABS(z);
      if x>y then begin
        x:=x+y;
        y:=x-y;
        x:=x-y;
      end;
    end;
    d:=2; x:=round(SQRT(x));
    While (d>1) and (d<=x) and (d>1) do begin
      If (c div d=c/d) and (z div d=z/d) then begin
        c:=c div d;
        z:=z div d;
        x:=ABS(c); y:=ABS(z);
        if x>y then begin
          x:=x+y;
          y:=x-y;
          x:=x-y;
        end;
        d:=2; x:=round(SQRT(x));
      end
      else begin
        d:=d+1;
      end;
    end;
  end;
end;


Procedure TDrob.Plus(Drob:TDrob);
Var x,y:integer;
begin
  y:=Z*Drob.Z;
  x:=C*Drob.Z+Drob.C*Z;
  C:=x; Z:=y;
  Simplify;
end;

Procedure TDrob.Minus(Drob:TDrob);
Var x,y:integer;
begin
  y:=Z*Drob.Z;
  x:=C*Drob.Z-Drob.C*Z;
  C:=x; Z:=y;
  Simplify;
end;

Procedure TDrob.Multiply(Drob:TDrob);
begin
  C:=Drob.C*C;
  Z:=Drob.Z*Z;
  Simplify;
end;

Procedure TDrob.Separate(Drob:TDrob);
begin
  C:=Drob.Z*C;
  Z:=Drob.C*Z;
  Simplify;
end;


end.

